/*******************************************************************************
* Copyright (c) 2000, 2004 IBM Corporation and others.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*       IBM Corporation - initial API and implementation
* D Port:
*       Jesse Phillips <Jesse.K.Phillips+D> gmail.com
*******************************************************************************/
module table.Snippet144;

/*
* Virtual Table example snippet: create a table with 1,000,000 items (lazy)
*
* For a list of all SWT example snippets see
* http://www.eclipse.org/swt/snippets/
*
* @since 3.0
*/
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.layout.RowData;

//import tango.core.tools.TraceExceptions;
import tango.io.Stdout;
import Integer = tango.text.convert.Integer;

import link;

const int COUNT = 5;

void main() {
    auto display = new Display ();
    auto shell = new Shell (display);
    shell.setLayout (new GridLayout(2, false));

    // left table
    auto table = new Table (shell, org.eclipse.swt.VIRTUAL | org.eclipse.swt.BORDER);
    table.addListener (org.eclipse.swt.SetData, new class Listener {
        public void handleEvent (Event event) {
            Stdout.formatln("GOOD: left table's SetData listener called");
            Stdout.formatln("{}", event.toString());
            auto item = cast(TableItem) event.item;
            auto index = table.indexOf (item);
            item.setText ("Item " ~ Integer.toString(index));
        }
    });

    // right table
    auto table2 = new Table (shell, org.eclipse.swt.VIRTUAL | org.eclipse.swt.BORDER);
    table2.addListener (org.eclipse.swt.SetData, new class Listener {
        public void handleEvent (Event event) {
            Stdout.formatln("BAD: right table's SetData listener called");
            Stdout.formatln("{}", event.toString());
            auto item = cast(TableItem) event.item;
            auto index = table.indexOf (item);
            item.setText ("Item " ~ Integer.toString(index));          
        }
    });

    auto button = new Button (shell, org.eclipse.swt.PUSH);
    button.setText ("Add Items");
    button.addListener (org.eclipse.swt.Selection, new class Listener {
        public void handleEvent (Event event) {
            table.setItemCount (COUNT);
        }
    });
    shell.pack ();
    shell.open ();
    while (!shell.isDisposed ()) {
        if (!display.readAndDispatch ()) display.sleep ();
    }
    display.dispose ();
}

